<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Decl. Expressions(overloading)</TITLE>
<link href="builder_33.html" rel=Next>
<link href="builder_31.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_31.html">previous</A>, <A HREF="builder_33.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC63" HREF="builder_toc.html#TOC63">Constructing Expressions Using Operator Overloading</A></H2>
<P>
<A NAME="IDX170"></A>

</P>
<P>
One neat feature of the builder is the ability to use the C++ parser to
parse and generate SUIF code.  This is achieved using operator
overloading. There are definitions for a full set of operator
overloading as shown below.
Expressions and statements can also be created using explicit
functions (See section <A HREF="builder_33.html#SEC64">Constructing Expressions Using Explicit Function Calls</A>).  
Building expressions using operator overloading is recommended when the 
exact structure of the expression is known at the compile time.

</P>
<P>
<A NAME="IDX171"></A>
<A NAME="IDX172"></A>
<A NAME="IDX173"></A>
<A NAME="IDX174"></A>
<A NAME="IDX175"></A>
<A NAME="IDX176"></A>

<PRE>
     block &#38; operator-()         
<A NAME="IDX177"></A><A NAME="IDX178"></A>     block &#38; operator!()         
<A NAME="IDX179"></A><A NAME="IDX180"></A>     block &#38; operator~()         
<A NAME="IDX181"></A><A NAME="IDX182"></A>
     block &#38; operator*(block &#38; b)
<A NAME="IDX183"></A><A NAME="IDX184"></A>     block &#38; operator/(block &#38; b)
<A NAME="IDX185"></A><A NAME="IDX186"></A>     block &#38; operator%(block &#38; b)
<A NAME="IDX187"></A><A NAME="IDX188"></A>     block &#38; operator+(block &#38; b)
<A NAME="IDX189"></A><A NAME="IDX190"></A>     block &#38; operator-(block &#38; b)
<A NAME="IDX191"></A><A NAME="IDX192"></A>     block &#38; operator&#60;&#60;(block &#38; b)
<A NAME="IDX193"></A><A NAME="IDX194"></A>     block &#38; operator&#62;&#62;(block &#38; b)
<A NAME="IDX195"></A><A NAME="IDX196"></A>     block &#38; operator&#60;(block &#38; b) 
<A NAME="IDX197"></A><A NAME="IDX198"></A>     block &#38; operator&#62;(block &#38; b) 
<A NAME="IDX199"></A><A NAME="IDX200"></A>     block &#38; operator&#60;=(block &#38; b)
<A NAME="IDX201"></A><A NAME="IDX202"></A>     block &#38; operator&#62;=(block &#38; b)
<A NAME="IDX203"></A><A NAME="IDX204"></A>     block &#38; operator==(block &#38; b)
<A NAME="IDX205"></A><A NAME="IDX206"></A>     block &#38; operator!=(block &#38; b)
<A NAME="IDX207"></A><A NAME="IDX208"></A>     block &#38; operator&#38;(block &#38; b) 
<A NAME="IDX209"></A><A NAME="IDX210"></A>     block &#38; operator^(block &#38; b) 
<A NAME="IDX211"></A><A NAME="IDX212"></A>     block &#38; operator|(block &#38; b) 
<A NAME="IDX213"></A><A NAME="IDX214"></A>     block &#38; operator&#38;&#38;(block &#38; b)
<A NAME="IDX215"></A><A NAME="IDX216"></A>     block &#38; operator||(block &#38; b)
<A NAME="IDX217"></A><A NAME="IDX218"></A>
     block &#38; operator=(block &#38; b) 
<A NAME="IDX219"></A><A NAME="IDX220"></A>     block &#38; operator+=(block &#38; b)
<A NAME="IDX221"></A><A NAME="IDX222"></A>     block &#38; operator-=(block &#38; b)
<A NAME="IDX223"></A><A NAME="IDX224"></A>     block &#38; operator*=(block &#38; b)
<A NAME="IDX225"></A><A NAME="IDX226"></A>     block &#38; operator/=(block &#38; b)
<A NAME="IDX227"></A><A NAME="IDX228"></A>     block &#38; operator%=(block &#38; b)
<A NAME="IDX229"></A><A NAME="IDX230"></A>     block &#38; operator&#62;&#62;=(block &#38; b)
<A NAME="IDX231"></A><A NAME="IDX232"></A>     block &#38; operator&#60;&#60;=(block &#38; b)
<A NAME="IDX233"></A><A NAME="IDX234"></A>     block &#38; operator&#38;=(block &#38; b) 
<A NAME="IDX235"></A><A NAME="IDX236"></A>     block &#38; operator^=(block &#38; b) 
<A NAME="IDX237"></A><A NAME="IDX238"></A>     block &#38; operator|=(block &#38; b) 
<A NAME="IDX239"></A><A NAME="IDX240"></A>
<A NAME="IDX241"></A>     block &#38; operator*(int b)  
<A NAME="IDX242"></A><A NAME="IDX243"></A>     block &#38; operator/(int b)  
<A NAME="IDX244"></A><A NAME="IDX245"></A>     block &#38; operator%(int b)  
<A NAME="IDX246"></A><A NAME="IDX247"></A>     block &#38; operator+(int b)  
<A NAME="IDX248"></A><A NAME="IDX249"></A>     block &#38; operator-(int b)  
<A NAME="IDX250"></A><A NAME="IDX251"></A>     block &#38; operator&#60;&#60;(int b) 
<A NAME="IDX252"></A><A NAME="IDX253"></A>     block &#38; operator&#62;&#62;(int b) 
<A NAME="IDX254"></A><A NAME="IDX255"></A>     block &#38; operator&#60;(int b)  
<A NAME="IDX256"></A><A NAME="IDX257"></A>     block &#38; operator&#62;(int b)  
<A NAME="IDX258"></A><A NAME="IDX259"></A>     block &#38; operator&#60;=(int b) 
<A NAME="IDX260"></A><A NAME="IDX261"></A>     block &#38; operator&#62;=(int b) 
<A NAME="IDX262"></A><A NAME="IDX263"></A>     block &#38; operator==(int b) 
<A NAME="IDX264"></A><A NAME="IDX265"></A>     block &#38; operator!=(int b) 
<A NAME="IDX266"></A><A NAME="IDX267"></A>     block &#38; operator&#38;(int b)  
<A NAME="IDX268"></A><A NAME="IDX269"></A>     block &#38; operator^(int b)  
<A NAME="IDX270"></A><A NAME="IDX271"></A>     block &#38; operator|(int b)  
<A NAME="IDX272"></A><A NAME="IDX273"></A>     block &#38; operator&#38;&#38;(int b) 
<A NAME="IDX274"></A><A NAME="IDX275"></A>     block &#38; operator||(int b) 
<A NAME="IDX276"></A><A NAME="IDX277"></A>
     block &#38; operator=(int b)  
<A NAME="IDX278"></A><A NAME="IDX279"></A>     block &#38; operator+=(int b) 
<A NAME="IDX280"></A><A NAME="IDX281"></A>     block &#38; operator-=(int b) 
<A NAME="IDX282"></A><A NAME="IDX283"></A>     block &#38; operator*=(int b) 
<A NAME="IDX284"></A><A NAME="IDX285"></A>     block &#38; operator/=(int b) 
<A NAME="IDX286"></A><A NAME="IDX287"></A>     block &#38; operator%=(int b) 
<A NAME="IDX288"></A><A NAME="IDX289"></A>     block &#38; operator&#62;&#62;=(int b)
<A NAME="IDX290"></A><A NAME="IDX291"></A>     block &#38; operator&#60;&#60;=(int b)
<A NAME="IDX292"></A><A NAME="IDX293"></A>     block &#38; operator&#38;=(int b) 
<A NAME="IDX294"></A><A NAME="IDX295"></A>     block &#38; operator^=(int b) 
<A NAME="IDX296"></A><A NAME="IDX297"></A>     block &#38; operator|=(int b) 
<A NAME="IDX298"></A><A NAME="IDX299"></A><A NAME="IDX300"></A>
<A NAME="IDX301"></A>     block &#38; operator*(double b)  
<A NAME="IDX302"></A><A NAME="IDX303"></A>     block &#38; operator/(double b)  
<A NAME="IDX304"></A><A NAME="IDX305"></A>     block &#38; operator%(double b)  
<A NAME="IDX306"></A><A NAME="IDX307"></A>     block &#38; operator+(double b)  
<A NAME="IDX308"></A><A NAME="IDX309"></A>     block &#38; operator-(double b)  
<A NAME="IDX310"></A><A NAME="IDX311"></A>     block &#38; operator&#60;&#60;(double b) 
<A NAME="IDX312"></A><A NAME="IDX313"></A>     block &#38; operator&#62;&#62;(double b) 
<A NAME="IDX314"></A><A NAME="IDX315"></A>     block &#38; operator&#60;(double b)  
<A NAME="IDX316"></A><A NAME="IDX317"></A>     block &#38; operator&#62;(double b)  
<A NAME="IDX318"></A><A NAME="IDX319"></A>     block &#38; operator&#60;=(double b) 
<A NAME="IDX320"></A><A NAME="IDX321"></A>     block &#38; operator&#62;=(double b) 
<A NAME="IDX322"></A><A NAME="IDX323"></A>     block &#38; operator==(double b) 
<A NAME="IDX324"></A><A NAME="IDX325"></A>     block &#38; operator!=(double b) 
<A NAME="IDX326"></A><A NAME="IDX327"></A>     block &#38; operator&#38;(double b)  
<A NAME="IDX328"></A><A NAME="IDX329"></A>     block &#38; operator^(double b)  
<A NAME="IDX330"></A><A NAME="IDX331"></A>     block &#38; operator|(double b)  
<A NAME="IDX332"></A><A NAME="IDX333"></A>     block &#38; operator&#38;&#38;(double b) 
<A NAME="IDX334"></A><A NAME="IDX335"></A>     block &#38; operator||(double b) 
<A NAME="IDX336"></A><A NAME="IDX337"></A>
     block &#38; operator=(double b)  
<A NAME="IDX338"></A><A NAME="IDX339"></A>     block &#38; operator+=(double b) 
<A NAME="IDX340"></A><A NAME="IDX341"></A>     block &#38; operator-=(double b) 
<A NAME="IDX342"></A><A NAME="IDX343"></A>     block &#38; operator*=(double b) 
<A NAME="IDX344"></A><A NAME="IDX345"></A>     block &#38; operator/=(double b) 
<A NAME="IDX346"></A><A NAME="IDX347"></A>     block &#38; operator%=(double b) 
<A NAME="IDX348"></A><A NAME="IDX349"></A>     block &#38; operator&#62;&#62;=(double b)
<A NAME="IDX350"></A><A NAME="IDX351"></A>     block &#38; operator&#60;&#60;=(double b)
<A NAME="IDX352"></A><A NAME="IDX353"></A>     block &#38; operator&#38;=(double b) 
<A NAME="IDX354"></A><A NAME="IDX355"></A>     block &#38; operator^=(double b) 
<A NAME="IDX356"></A><A NAME="IDX357"></A>     block &#38; operator|=(double b) 
<A NAME="IDX358"></A><A NAME="IDX359"></A><A NAME="IDX360"></A>
<A NAME="IDX361"></A>     block &#38; operator*(float b)  
<A NAME="IDX362"></A><A NAME="IDX363"></A>     block &#38; operator/(float b)  
<A NAME="IDX364"></A><A NAME="IDX365"></A>     block &#38; operator%(float b)  
<A NAME="IDX366"></A><A NAME="IDX367"></A>     block &#38; operator+(float b)  
<A NAME="IDX368"></A><A NAME="IDX369"></A>     block &#38; operator-(float b)  
<A NAME="IDX370"></A><A NAME="IDX371"></A>     block &#38; operator&#60;&#60;(float b) 
<A NAME="IDX372"></A><A NAME="IDX373"></A>     block &#38; operator&#62;&#62;(float b) 
<A NAME="IDX374"></A><A NAME="IDX375"></A>     block &#38; operator&#60;(float b)  
<A NAME="IDX376"></A><A NAME="IDX377"></A>     block &#38; operator&#62;(float b)  
<A NAME="IDX378"></A><A NAME="IDX379"></A>     block &#38; operator&#60;=(float b) 
<A NAME="IDX380"></A><A NAME="IDX381"></A>     block &#38; operator&#62;=(float b) 
<A NAME="IDX382"></A><A NAME="IDX383"></A>     block &#38; operator==(float b) 
<A NAME="IDX384"></A><A NAME="IDX385"></A>     block &#38; operator!=(float b) 
<A NAME="IDX386"></A><A NAME="IDX387"></A>     block &#38; operator&#38;(float b)  
<A NAME="IDX388"></A><A NAME="IDX389"></A>     block &#38; operator^(float b)  
<A NAME="IDX390"></A><A NAME="IDX391"></A>     block &#38; operator|(float b)  
<A NAME="IDX392"></A><A NAME="IDX393"></A>     block &#38; operator&#38;&#38;(float b) 
<A NAME="IDX394"></A><A NAME="IDX395"></A>     block &#38; operator||(float b) 
<A NAME="IDX396"></A><A NAME="IDX397"></A>
     block &#38; operator=(float b)  
<A NAME="IDX398"></A><A NAME="IDX399"></A>     block &#38; operator+=(float b) 
<A NAME="IDX400"></A><A NAME="IDX401"></A>     block &#38; operator-=(float b) 
<A NAME="IDX402"></A><A NAME="IDX403"></A>     block &#38; operator*=(float b) 
<A NAME="IDX404"></A><A NAME="IDX405"></A>     block &#38; operator/=(float b) 
<A NAME="IDX406"></A><A NAME="IDX407"></A>     block &#38; operator%=(float b) 
<A NAME="IDX408"></A><A NAME="IDX409"></A>     block &#38; operator&#62;&#62;=(float b)
<A NAME="IDX410"></A><A NAME="IDX411"></A>     block &#38; operator&#60;&#60;=(float b)
<A NAME="IDX412"></A><A NAME="IDX413"></A>     block &#38; operator&#38;=(float b) 
<A NAME="IDX414"></A><A NAME="IDX415"></A>     block &#38; operator^=(float b) 
<A NAME="IDX416"></A><A NAME="IDX417"></A>     block &#38; operator|=(float b) 
<A NAME="IDX418"></A><A NAME="IDX419"></A><A NAME="IDX420"></A>
<A NAME="IDX421"></A>     block &#38; operator*(char * b)  
<A NAME="IDX422"></A><A NAME="IDX423"></A>     block &#38; operator/(char * b)  
<A NAME="IDX424"></A><A NAME="IDX425"></A>     block &#38; operator%(char * b)  
<A NAME="IDX426"></A><A NAME="IDX427"></A>     block &#38; operator+(char * b)  
<A NAME="IDX428"></A><A NAME="IDX429"></A>     block &#38; operator-(char * b)  
<A NAME="IDX430"></A><A NAME="IDX431"></A>     block &#38; operator&#60;&#60;(char * b) 
<A NAME="IDX432"></A><A NAME="IDX433"></A>     block &#38; operator&#62;&#62;(char * b) 
<A NAME="IDX434"></A><A NAME="IDX435"></A>     block &#38; operator&#60;(char * b)  
<A NAME="IDX436"></A><A NAME="IDX437"></A>     block &#38; operator&#62;(char * b)  
<A NAME="IDX438"></A><A NAME="IDX439"></A>     block &#38; operator&#60;=(char * b) 
<A NAME="IDX440"></A><A NAME="IDX441"></A>     block &#38; operator&#62;=(char * b) 
<A NAME="IDX442"></A><A NAME="IDX443"></A>     block &#38; operator==(char * b) 
<A NAME="IDX444"></A><A NAME="IDX445"></A>     block &#38; operator!=(char * b) 
<A NAME="IDX446"></A><A NAME="IDX447"></A>     block &#38; operator&#38;(char * b)  
<A NAME="IDX448"></A><A NAME="IDX449"></A>     block &#38; operator^(char * b)  
<A NAME="IDX450"></A><A NAME="IDX451"></A>     block &#38; operator|(char * b)  
<A NAME="IDX452"></A><A NAME="IDX453"></A>     block &#38; operator&#38;&#38;(char * b) 
<A NAME="IDX454"></A><A NAME="IDX455"></A>     block &#38; operator||(char * b) 
<A NAME="IDX456"></A><A NAME="IDX457"></A>
     block &#38; operator=(char * b)  
<A NAME="IDX458"></A><A NAME="IDX459"></A>     block &#38; operator+=(char * b) 
<A NAME="IDX460"></A><A NAME="IDX461"></A>     block &#38; operator-=(char * b) 
<A NAME="IDX462"></A><A NAME="IDX463"></A>     block &#38; operator*=(char * b) 
<A NAME="IDX464"></A><A NAME="IDX465"></A>     block &#38; operator/=(char * b) 
<A NAME="IDX466"></A><A NAME="IDX467"></A>     block &#38; operator%=(char * b) 
<A NAME="IDX468"></A><A NAME="IDX469"></A>     block &#38; operator&#62;&#62;=(char * b)
<A NAME="IDX470"></A><A NAME="IDX471"></A>     block &#38; operator&#60;&#60;=(char * b)
<A NAME="IDX472"></A><A NAME="IDX473"></A>     block &#38; operator&#38;=(char * b) 
<A NAME="IDX474"></A><A NAME="IDX475"></A>     block &#38; operator^=(char * b) 
<A NAME="IDX476"></A><A NAME="IDX477"></A>     block &#38; operator|=(char * b) 
<A NAME="IDX478"></A><A NAME="IDX479"></A><A NAME="IDX480"></A>
     block &#38; max(block &#38;a, 
                 block &#38;b) 
<A NAME="IDX481"></A>     block &#38; min(block &#38;a, 
                 block &#38;b)  
<A NAME="IDX482"></A>     block &#38; mod(block &#38;a, 
                 block &#38;b)  
<A NAME="IDX483"></A>     block &#38; abs(block &#38;a) 
<A NAME="IDX484"></A></PRE>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_31.html">previous</A>, <A HREF="builder_33.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
